/**
 * file-manager-js
 * @copyright 2018 Eyas Ranjous <eyas.ranjous@gmail.com>
 * @license MIT
 */

const { join } = require('path');
const stat = require('./lib/stat');
const info = require('./lib/info');
const list = require('./lib/list');
const listDeep = require('./lib/listDeep');
const exists = require('./lib/exists');
const rename = require('./lib/rename');
const createDir = require('./lib/createDir');
const removeDir = require('./lib/removeDir');
const createFile = require('./lib/createFile');
const readFile = require('./lib/readFile');
const removeFile = require('./lib/removeFile');

// fileManager api
module.exports = {
  join,
  stat,
  info,
  list,
  listDeep,
  exists,
  rename,
  createDir,
  removeDir,
  createFile,
  readFile,
  removeFile
};
